/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#ifndef _NFS_H_RPCGEN
#define _NFS_H_RPCGEN

#include <rpc/rpc.h>


#ifdef __cplusplus
extern "C" {
#endif

#define NFS_MAXDATA 8192
#define NFS_MAXPATHLEN 1024
#define NFS_MAXNAMLEN 255
#define NFS_COOKIESIZE 4
#define NFS_FHSIZE 32

enum nfs_stat {
	NFS_OK = 0,
	NFSERR_PERM = 1,
	NFSERR_NOENT = 2,
	NFSERR_IO = 5,
	NFSERR_NXIO = 6,
	NFSERR_ACCES = 13,
	NFSERR_EXIST = 17,
	NFSERR_NODEV = 19,
	NFSERR_NOTDIR = 20,
	NFSERR_ISDIR = 21,
	NFSERR_FBIG = 27,
	NFSERR_NOSPC = 28,
	NFSERR_ROFS = 30,
	NFSERR_NAMETOOLONG = 63,
	NFSERR_NOTEMPTY = 66,
	NFSERR_DQUOT = 69,
	NFSERR_STALE = 70,
	NFSERR_WFLUSH = 99,
};
typedef enum nfs_stat nfs_stat;

typedef char fhandle[NFS_FHSIZE];

typedef char *filename;

typedef char *path;

typedef struct {
	u_int nfsdata_len;
	char *nfsdata_val;
} nfsdata;

typedef char nfscookie[NFS_COOKIESIZE];

enum ftype {
	NFNON = 0,
	NFREG = 1,
	NFDIR = 2,
	NFBLK = 3,
	NFCHR = 4,
	NFLNK = 5,
};
typedef enum ftype ftype;

struct nfs_timeval {
	u_int seconds;
	u_int useconds;
};
typedef struct nfs_timeval nfs_timeval;

struct sattr {
	u_int mode;
	u_int uid;
	u_int gid;
	u_int size;
	nfs_timeval atime;
	nfs_timeval mtime;
};
typedef struct sattr sattr;

struct fattr {
	ftype type;
	u_int mode;
	u_int nlink;
	u_int uid;
	u_int gid;
	u_int size;
	u_int blocksize;
	u_int rdev;
	u_int blocks;
	u_int fsid;
	u_int fileid;
	nfs_timeval atime;
	nfs_timeval mtime;
	nfs_timeval ctime;
};
typedef struct fattr fattr;

struct sattrargs {
	fhandle file;
	sattr attributes;
};
typedef struct sattrargs sattrargs;

struct diropresok {
	fhandle file;
	fattr attributes;
};
typedef struct diropresok diropresok;

struct diropres {
	nfs_stat status;
	union {
		struct diropresok diropok;
	} diropres_u;
};
typedef struct diropres diropres;

struct diropargs {
	fhandle dir;
	filename name;
};
typedef struct diropargs diropargs;

struct attrstat {
	nfs_stat status;
	union {
		fattr attributes;
	} attrstat_u;
};
typedef struct attrstat attrstat;

struct readdirargs {
	fhandle dir;
	nfscookie cookie;
	u_int count;
};
typedef struct readdirargs readdirargs;

struct entry {
	u_int fileid;
	filename name;
	nfscookie cookie;
	struct entry *nextentry;
};
typedef struct entry entry;

struct createargs {
	diropargs where;
	sattr attributes;
};
typedef struct createargs createargs;

struct renameargs {
	diropargs from;
	diropargs to;
};
typedef struct renameargs renameargs;

struct linkargs {
	fhandle from;
	diropargs to;
};
typedef struct linkargs linkargs;

struct symlinkargs {
	diropargs from;
	path to;
	sattr attributes;
};
typedef struct symlinkargs symlinkargs;

struct writeargs {
	fhandle file;
	u_int beginoffset;
	u_int offset;
	u_int totalcount;
	nfsdata data;
};
typedef struct writeargs writeargs;

struct readlinkres {
	nfs_stat status;
	union {
		path data;
	} readlinkres_u;
};
typedef struct readlinkres readlinkres;

struct readargs {
	fhandle file;
	u_int offset;
	u_int count;
	u_int totalcount;
};
typedef struct readargs readargs;

struct readresok {
	fattr attributes;
	nfsdata data;
};
typedef struct readresok readresok;

struct readres {
	nfs_stat status;
	union {
		struct readresok readok;
	} readres_u;
};
typedef struct readres readres;

struct statfsresok {
	u_int tsize;
	u_int bsize;
	u_int blocks;
	u_int bfree;
	u_int bavail;
};
typedef struct statfsresok statfsresok;

struct statfsres {
	nfs_stat status;
	union {
		struct statfsresok info;
	} statfsres_u;
};
typedef struct statfsres statfsres;

struct readdirresok {
	entry *entries;
	bool_t eof;
};
typedef struct readdirresok readdirresok;

struct readdirres {
	nfs_stat status;
	union {
		struct readdirresok readdirok;
	} readdirres_u;
};
typedef struct readdirres readdirres;

#define NFS_PROGRAM 100003
#define NFS_VERSION 2

#if defined(__STDC__) || defined(__cplusplus)
#define NFSPROC_NULL 0
extern  void * nfsproc_null_2(void *, CLIENT *);
extern  void * nfsproc_null_2_svc(void *, struct svc_req *);
#define NFSPROC_GETATTR 1
extern  attrstat * nfsproc_getattr_2(char *, CLIENT *);
extern  attrstat * nfsproc_getattr_2_svc(char *, struct svc_req *);
#define NFSPROC_SETATTR 2
extern  attrstat * nfsproc_setattr_2(sattrargs *, CLIENT *);
extern  attrstat * nfsproc_setattr_2_svc(sattrargs *, struct svc_req *);
#define NFSPROC_ROOT 3
extern  void * nfsproc_root_2(void *, CLIENT *);
extern  void * nfsproc_root_2_svc(void *, struct svc_req *);
#define NFSPROC_LOOKUP 4
extern  diropres * nfsproc_lookup_2(diropargs *, CLIENT *);
extern  diropres * nfsproc_lookup_2_svc(diropargs *, struct svc_req *);
#define NFSPROC_READLINK 5
extern  readlinkres * nfsproc_readlink_2(char *, CLIENT *);
extern  readlinkres * nfsproc_readlink_2_svc(char *, struct svc_req *);
#define NFSPROC_READ 6
extern  readres * nfsproc_read_2(readargs *, CLIENT *);
extern  readres * nfsproc_read_2_svc(readargs *, struct svc_req *);
#define NFSPROC_WRITECACHE 7
extern  void * nfsproc_writecache_2(void *, CLIENT *);
extern  void * nfsproc_writecache_2_svc(void *, struct svc_req *);
#define NFSPROC_WRITE 8
extern  attrstat * nfsproc_write_2(writeargs *, CLIENT *);
extern  attrstat * nfsproc_write_2_svc(writeargs *, struct svc_req *);
#define NFSPROC_CREATE 9
extern  diropres * nfsproc_create_2(createargs *, CLIENT *);
extern  diropres * nfsproc_create_2_svc(createargs *, struct svc_req *);
#define NFSPROC_REMOVE 10
extern  nfs_stat * nfsproc_remove_2(diropargs *, CLIENT *);
extern  nfs_stat * nfsproc_remove_2_svc(diropargs *, struct svc_req *);
#define NFSPROC_RENAME 11
extern  nfs_stat * nfsproc_rename_2(renameargs *, CLIENT *);
extern  nfs_stat * nfsproc_rename_2_svc(renameargs *, struct svc_req *);
#define NFSPROC_LINK 12
extern  nfs_stat * nfsproc_link_2(linkargs *, CLIENT *);
extern  nfs_stat * nfsproc_link_2_svc(linkargs *, struct svc_req *);
#define NFSPROC_SYMLINK 13
extern  nfs_stat * nfsproc_symlink_2(symlinkargs *, CLIENT *);
extern  nfs_stat * nfsproc_symlink_2_svc(symlinkargs *, struct svc_req *);
#define NFSPROC_MKDIR 14
extern  diropres * nfsproc_mkdir_2(createargs *, CLIENT *);
extern  diropres * nfsproc_mkdir_2_svc(createargs *, struct svc_req *);
#define NFSPROC_RMDIR 15
extern  nfs_stat * nfsproc_rmdir_2(diropargs *, CLIENT *);
extern  nfs_stat * nfsproc_rmdir_2_svc(diropargs *, struct svc_req *);
#define NFSPROC_READDIR 16
extern  readdirres * nfsproc_readdir_2(readdirargs *, CLIENT *);
extern  readdirres * nfsproc_readdir_2_svc(readdirargs *, struct svc_req *);
#define NFSPROC_STATFS 17
extern  statfsres * nfsproc_statfs_2(char *, CLIENT *);
extern  statfsres * nfsproc_statfs_2_svc(char *, struct svc_req *);
extern int nfs_program_2_freeresult (SVCXPRT *, xdrproc_t, caddr_t);

#else /* K&R C */
#define NFSPROC_NULL 0
extern  void * nfsproc_null_2();
extern  void * nfsproc_null_2_svc();
#define NFSPROC_GETATTR 1
extern  attrstat * nfsproc_getattr_2();
extern  attrstat * nfsproc_getattr_2_svc();
#define NFSPROC_SETATTR 2
extern  attrstat * nfsproc_setattr_2();
extern  attrstat * nfsproc_setattr_2_svc();
#define NFSPROC_ROOT 3
extern  void * nfsproc_root_2();
extern  void * nfsproc_root_2_svc();
#define NFSPROC_LOOKUP 4
extern  diropres * nfsproc_lookup_2();
extern  diropres * nfsproc_lookup_2_svc();
#define NFSPROC_READLINK 5
extern  readlinkres * nfsproc_readlink_2();
extern  readlinkres * nfsproc_readlink_2_svc();
#define NFSPROC_READ 6
extern  readres * nfsproc_read_2();
extern  readres * nfsproc_read_2_svc();
#define NFSPROC_WRITECACHE 7
extern  void * nfsproc_writecache_2();
extern  void * nfsproc_writecache_2_svc();
#define NFSPROC_WRITE 8
extern  attrstat * nfsproc_write_2();
extern  attrstat * nfsproc_write_2_svc();
#define NFSPROC_CREATE 9
extern  diropres * nfsproc_create_2();
extern  diropres * nfsproc_create_2_svc();
#define NFSPROC_REMOVE 10
extern  nfs_stat * nfsproc_remove_2();
extern  nfs_stat * nfsproc_remove_2_svc();
#define NFSPROC_RENAME 11
extern  nfs_stat * nfsproc_rename_2();
extern  nfs_stat * nfsproc_rename_2_svc();
#define NFSPROC_LINK 12
extern  nfs_stat * nfsproc_link_2();
extern  nfs_stat * nfsproc_link_2_svc();
#define NFSPROC_SYMLINK 13
extern  nfs_stat * nfsproc_symlink_2();
extern  nfs_stat * nfsproc_symlink_2_svc();
#define NFSPROC_MKDIR 14
extern  diropres * nfsproc_mkdir_2();
extern  diropres * nfsproc_mkdir_2_svc();
#define NFSPROC_RMDIR 15
extern  nfs_stat * nfsproc_rmdir_2();
extern  nfs_stat * nfsproc_rmdir_2_svc();
#define NFSPROC_READDIR 16
extern  readdirres * nfsproc_readdir_2();
extern  readdirres * nfsproc_readdir_2_svc();
#define NFSPROC_STATFS 17
extern  statfsres * nfsproc_statfs_2();
extern  statfsres * nfsproc_statfs_2_svc();
extern int nfs_program_2_freeresult ();
#endif /* K&R C */

/* the xdr functions */

#if defined(__STDC__) || defined(__cplusplus)
extern  bool_t xdr_nfs_stat (XDR *, nfs_stat*);
extern  bool_t xdr_fhandle (XDR *, fhandle);
extern  bool_t xdr_filename (XDR *, filename*);
extern  bool_t xdr_path (XDR *, path*);
extern  bool_t xdr_nfsdata (XDR *, nfsdata*);
extern  bool_t xdr_nfscookie (XDR *, nfscookie);
extern  bool_t xdr_ftype (XDR *, ftype*);
extern  bool_t xdr_nfs_timeval (XDR *, nfs_timeval*);
extern  bool_t xdr_sattr (XDR *, sattr*);
extern  bool_t xdr_fattr (XDR *, fattr*);
extern  bool_t xdr_sattrargs (XDR *, sattrargs*);
extern  bool_t xdr_diropresok (XDR *, diropresok*);
extern  bool_t xdr_diropres (XDR *, diropres*);
extern  bool_t xdr_diropargs (XDR *, diropargs*);
extern  bool_t xdr_attrstat (XDR *, attrstat*);
extern  bool_t xdr_readdirargs (XDR *, readdirargs*);
extern  bool_t xdr_entry (XDR *, entry*);
extern  bool_t xdr_createargs (XDR *, createargs*);
extern  bool_t xdr_renameargs (XDR *, renameargs*);
extern  bool_t xdr_linkargs (XDR *, linkargs*);
extern  bool_t xdr_symlinkargs (XDR *, symlinkargs*);
extern  bool_t xdr_writeargs (XDR *, writeargs*);
extern  bool_t xdr_readlinkres (XDR *, readlinkres*);
extern  bool_t xdr_readargs (XDR *, readargs*);
extern  bool_t xdr_readresok (XDR *, readresok*);
extern  bool_t xdr_readres (XDR *, readres*);
extern  bool_t xdr_statfsresok (XDR *, statfsresok*);
extern  bool_t xdr_statfsres (XDR *, statfsres*);
extern  bool_t xdr_readdirresok (XDR *, readdirresok*);
extern  bool_t xdr_readdirres (XDR *, readdirres*);

#else /* K&R C */
extern bool_t xdr_nfs_stat ();
extern bool_t xdr_fhandle ();
extern bool_t xdr_filename ();
extern bool_t xdr_path ();
extern bool_t xdr_nfsdata ();
extern bool_t xdr_nfscookie ();
extern bool_t xdr_ftype ();
extern bool_t xdr_nfs_timeval ();
extern bool_t xdr_sattr ();
extern bool_t xdr_fattr ();
extern bool_t xdr_sattrargs ();
extern bool_t xdr_diropresok ();
extern bool_t xdr_diropres ();
extern bool_t xdr_diropargs ();
extern bool_t xdr_attrstat ();
extern bool_t xdr_readdirargs ();
extern bool_t xdr_entry ();
extern bool_t xdr_createargs ();
extern bool_t xdr_renameargs ();
extern bool_t xdr_linkargs ();
extern bool_t xdr_symlinkargs ();
extern bool_t xdr_writeargs ();
extern bool_t xdr_readlinkres ();
extern bool_t xdr_readargs ();
extern bool_t xdr_readresok ();
extern bool_t xdr_readres ();
extern bool_t xdr_statfsresok ();
extern bool_t xdr_statfsres ();
extern bool_t xdr_readdirresok ();
extern bool_t xdr_readdirres ();

#endif /* K&R C */

#ifdef __cplusplus
}
#endif

#endif /* !_NFS_H_RPCGEN */
